/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Digital dosimeter  
Version : v2 
Date    : 11.8.2013
Author  : Ji ech 
Company : Silicon-Source HW&SW
Comments: All rights reserved


Chip type               : ATmega162
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega162.h>



// Alphanumeric LCD Module functions
#include <delay.h>

// Alphanumeric LCD Module functions
#include <alcd.h>


#include <stdlib.h>




unsigned long  int cpm; //cycles per minute
unsigned long int cph;  //cycles per hour
char s;                 //second
char m;                 //minute
char n;                 //x norm overflow
eeprom unsigned long int ctt; // total pulses
unsigned long int urh; //uR/h sampling every minute
unsigned long int mrh; //mR/h used only, when "urh" is too large

unsigned long int urhfive;// uR/h sampling every 5 seconds
unsigned char five;       // counter 5 seconds
unsigned long int cpfive; // cycles per 5 seconds
unsigned char mrhsetfive;  // switching between uR/h and mR/h per 5 seconds
unsigned long int mrhfive; //mR/h used only, when "urh" is too large per 5 seconds

char sm;                  // countdown timer for time notification

unsigned char setup=1;     // if 1, start loading (Voltage stabilisation) if 0, GMT works. 
                          // Dosimeter can switch it to 0 automatically.
unsigned char mrhset;     // switching between uR/h and mR/h

eeprom unsigned char license;    //license
unsigned char licensesel;        //license
unsigned char cllicset=1; //lcd_clear(); only once







unsigned char ava=0;       //license
unsigned char avb=0;       //license
unsigned char avc=0;       //license
unsigned char avd=0;       //license
unsigned char ave=0;       //license
unsigned char avf=0;       //license
unsigned char avg=0;       //license
unsigned char avh=0;       //license
unsigned char avi=0;       //license
unsigned char avj=0;       //license
unsigned char avk=0;       //license
unsigned char avl=0;       //license
unsigned char avm=0;       //license
unsigned char avn=0;       //license
unsigned char avo=0;       //license
unsigned char avp=0;       //license
unsigned char avq=0;       //license

unsigned char a;       //license
unsigned char b;       //license
unsigned char c;       //license
unsigned char d;       //license
unsigned char e;       //license
unsigned char f;       //license
unsigned char g;       //license
unsigned char h;       //license
unsigned char i;       //license
unsigned char j;       //license
unsigned char k;       //license
unsigned char l;       //license
unsigned char m;       //license
unsigned char n;       //license
unsigned char o;       //license
unsigned char p;       //license
unsigned char q;       //license

unsigned char ac[3];       //license
unsigned char bc[3];       //license
unsigned char cc[3];       //license
unsigned char dc[3];       //license
unsigned char ec[3];       //license
unsigned char fc[3];       //license
unsigned char gc[3];       //license
unsigned char hc[3];       //license
unsigned char ic[3];       //license
unsigned char jc[3];       //license
unsigned char kc[3];       //license
unsigned char lc[3];       //license
unsigned char mc[3];       //license
unsigned char ncc[3];       //license
unsigned char oc[3];       //license
unsigned char pc[3];       //license
unsigned char qc[3];       //license
               

//variables converted to ASCII. Name was created, like name of variable and added was suffix "c"
unsigned char urhfivec[15];
unsigned char mrhfivec[15];
unsigned char cpmc[15];
unsigned char cphc[15];
unsigned char cttc[27];
unsigned char sc[6];
unsigned char urhc[15];
unsigned char nc[9];
unsigned char mrhc[15];




// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
 {
   
        
        
    

if(setup!=1){

cpfive++;
cpm++;
cph++;
ctt++;






ltoa(ctt,cttc);


if(ctt<10){
lcd_gotoxy(6,3);
lcd_puts("000000000");
lcd_gotoxy(15,3);
lcd_puts(cttc);
}

if(ctt>9 && ctt<100){
lcd_gotoxy(6,3);
lcd_puts("00000000");
lcd_gotoxy(14,3);
lcd_puts(cttc);
}

if(ctt>99 && ctt<1000){
lcd_gotoxy(6,3);
lcd_puts("0000000");
lcd_gotoxy(13,3);
lcd_puts(cttc);
}

if(ctt>999 && ctt<10000){
lcd_gotoxy(6,3);
lcd_puts("000000");
lcd_gotoxy(12,3);
lcd_puts(cttc);
}

if(ctt>9999 && ctt<100000 ){
lcd_gotoxy(6,3);
lcd_puts("00000");
lcd_gotoxy(11,3);
lcd_puts(cttc);
}
if(ctt>99999 && ctt<100000){
lcd_gotoxy(6,3);
lcd_puts("0000");
lcd_gotoxy(10,3);
lcd_puts(cttc);
}
if(ctt>999999 && ctt<1000000){
lcd_gotoxy(6,3);
lcd_puts("000");
lcd_gotoxy(9,3);
lcd_puts(cttc);

}

if(ctt>999999 && ctt<1000000){
lcd_gotoxy(6,3);
lcd_puts("00");
lcd_gotoxy(8,3);
lcd_puts(cttc);
}

if(ctt>9999999 && ctt<10000000){
lcd_gotoxy(6,3);
lcd_puts("0");
lcd_gotoxy(7,3);
lcd_puts(cttc);
}

if(ctt>99999999 && ctt<100000000){
lcd_gotoxy(6,3);
lcd_puts(cttc);
}

if(ctt>9999999999){
lcd_gotoxy(6,3);
lcd_puts("-overflow-");
}

}
}



// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here
five++;


 while(license!=1){ 
    if(cllicset==1){ 
    lcd_clear();  
    cllicset=0; 
    }
    lcd_gotoxy(0,0);
    lcd_puts("Activate firmware!");
    lcd_gotoxy(4,1);
    lcd_puts("|");
    lcd_gotoxy(9,1);
    lcd_puts("|");
    lcd_gotoxy(14,1);
    lcd_puts("|");
    lcd_gotoxy(0,2);
    lcd_puts("Digital dosimeter SS");
    lcd_gotoxy(2,3);
    lcd_puts("> select | # enter");

        
        
        if(PINC.1==1){
        delay_ms(80);
        if(PINC.1==1){
        while(PINC.1==1){}
        if(licensesel<18){
        licensesel++; 
        }
        if(licensesel>17){
        licensesel=0;
        } 
        }
        }
        
 
        
        if(licensesel==0 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(a!=10){
        a++;  
        }
        if(a==10){
        a=0; 
        }
        } 
        
        if(licensesel==1 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(b!=10){
        b++;  
        }
        if(b==10){
        b=0; 
        }
        }  
        
        if(licensesel==2 && PINC.0==1)
        {
        while(PINC.0==1){}
        if(c!=10){
        c++;  
        }
        if(c==10){
        c=0; 
        }
        
        
        }  
        
        if(licensesel==3 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(d!=10){
        d++;  
        }
        if(d==10){
        d=0; 
        }
        
        
        }   
        
        if(licensesel==4 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(e!=10){
        e++;  
        }
        if(e==10){
        e=0; 
        }
        
       
        }  
        
        if(licensesel==5 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(f!=10){
        f++;  
        }
        if(f==10){
        f=0;
        } 
        
        
        }  
        
        if(licensesel==6 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(g!=10){
        g++;  
        }
        if(g==10){
        g=0; 
        }
        
       
        }  
        
        if(licensesel==7 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(h!=10){
        h++;  
        }
        if(h==10){
        h=0;
        }
        
       
        }  
        
        if(licensesel==8 && PINC.0==1)
        {   
        while(PINC.0==1){}
        if(i!=10){
        i++;  
        }
        if(i==10){
        i=0;
        } 
        
        
        }   
        
        if(licensesel==9 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(j!=10){
        j++;  
        }
        if(j==10){
        j=0; 
        }
        
        
        }  
        
        if(licensesel==10 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(k!=10){
        k++;  
        }
        if(k==10){
        k=0;
        }
        
       
        }  
        
        if(licensesel==11 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(l!=10){
        l++;  
        }
        if(l==10){
        l=0;  
        }
        
        
        }  
        
        if(licensesel==12 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(m!=10){
        m++;  
        }
        if(m==10){
        m=0;
        } 
        
       
        }  
        
        if(licensesel==13 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(n!=10){
        n++;  
        }
        if(n==10){
        n=0; 
        }
        
       
        }  
        
        if(licensesel==14 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(o!=10){
        o++;  
        }
        if(o==10){
        o=0;  
        }
        
        
        }  
        
        if(licensesel==15 && PINC.0==1)
        {  
        while(PINC.0==1){}
        if(p!=10){
        p++;  
        }
        if(p==10){
        p=0; 
        }
        
       
        }
        
          
        
        if(licensesel==16 && PINC.0==1)
        { 
        while(PINC.0==1){}
        if(q!=10){
        q++;  
        }
        if(q==10){
        q=0; 
        }
        }  
        
        itoa(a,ac);
        itoa(b,bc);
        itoa(c,cc);
        itoa(d,dc);
        itoa(e,ec);
        itoa(f,fc);
        itoa(g,gc);
        itoa(h,hc);
        itoa(i,ic);
        itoa(j,jc);
        itoa(k,kc);
        itoa(l,lc);
        itoa(m,mc);
        itoa(n,ncc);
        itoa(o,oc);
        itoa(p,pc);
        itoa(q,qc);
        
        lcd_gotoxy(0,1);
        lcd_puts(ac); 
        
        lcd_gotoxy(1,1);
        lcd_puts(bc);
        
        lcd_gotoxy(2,1);
        lcd_puts(cc);
        
        lcd_gotoxy(3,1);
        lcd_puts(dc);
        
        lcd_gotoxy(5,1);
        lcd_puts(ec);
        
        lcd_gotoxy(6,1);
        lcd_puts(fc);
        
        lcd_gotoxy(7,1);
        lcd_puts(gc);
        
        lcd_gotoxy(8,1);
        lcd_puts(hc);
        
        lcd_gotoxy(10,1);
        lcd_puts(ic);
        
        lcd_gotoxy(11,1);
        lcd_puts(jc);
        
        lcd_gotoxy(12,1);
        lcd_puts(kc);
        
        lcd_gotoxy(13,1);
        lcd_puts(lc);
        
        lcd_gotoxy(15,1);
        lcd_puts(mc);
        
        lcd_gotoxy(16,1);
        lcd_puts(ncc);
        
        lcd_gotoxy(17,1);
        lcd_puts(oc);
        
        lcd_gotoxy(18,1);
        lcd_puts(pc);
        
        lcd_gotoxy(19,1);
        lcd_puts(qc);
        
        
        
        
        
 if(licensesel==17){ 
         while(PINC.1==1){}
     
        
       if(a==ava){
        if(b==avb){
         if(c==avc){
          if(d==avd){
           if(e==ave){
            if(f==avf){
             if(g==avg){
              if(h==avh){
               if(i==avi){
                if(j==avj){
                 if(k==avk){
                  if(l==avl){
                   if(m==avm){
                    if(n==avn){
                     if(o==avo){
                      if(p==avp){ 
                       if(q==avq){
                      
                      license=1; 
                      
                      lcd_clear(); 
                      
                      lcd_gotoxy(5,0);
                      lcd_puts("Activated!");  
                      
                      lcd_gotoxy(0,1);
                      lcd_puts("Thanks you for using"); 
                      
                      lcd_gotoxy(2,2);
                      lcd_puts("this product !"); 
                      
                      lcd_gotoxy(0,3);
                      lcd_puts("Silicon-Source HW&SW");  
                      
                       
                      if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }     
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                      
                      
                       if(PINC.1!=1||PINC.0!=1){
                       delay_ms(100);
                      if(PINC.1!=1||PINC.0!=1){
                      delay_ms(250);
                      }    
                      }
                     
                      
                      
                      
                      
                      
                      
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       }
       } 
       }
  }      
        
    
  }
   
  
  

  
if(setup==1){
setup=0;
lcd_clear();
lcd_gotoxy(0,0);
lcd_puts("Digital dosimeter v2");
lcd_gotoxy(0,2);
lcd_puts("Loading, please wait");
lcd_gotoxy(0,3);
lcd_puts("(c) Jiri Cech 8/2013");

delay_ms(200);
lcd_gotoxy(0,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(1,1);
lcd_putchar(0xFF);


delay_ms(200);
lcd_gotoxy(2,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(3,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(4,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(5,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(6,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(7,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(8,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(9,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(10,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(11,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(12,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(13,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(14,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(15,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(16,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(17,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(18,1);
lcd_putchar(0xFF);

delay_ms(200);
lcd_gotoxy(19,1);
lcd_putchar(0xFF);

lcd_clear();




lcd_gotoxy(10,1);
lcd_puts("|");

lcd_gotoxy(17,1);
lcd_puts("cpm");

lcd_gotoxy(0,0);
lcd_puts("UPDATE:");

lcd_gotoxy(9,0);
lcd_puts("s");

lcd_gotoxy(10,0);
lcd_puts("|");


lcd_gotoxy(17,2);
lcd_puts("cph");

lcd_gotoxy(10,2);
lcd_puts("|");



lcd_gotoxy(5,3);
lcd_puts("|");


lcd_gotoxy(17,3);
lcd_puts("ctt");

lcd_gotoxy(0,1);
lcd_puts("-----");

lcd_gotoxy(0,2);
lcd_puts("-----");

lcd_gotoxy(0,3);
lcd_puts("----");

lcd_gotoxy(11,1);
lcd_puts("-----");

lcd_gotoxy(11,2);
lcd_puts("-----");

lcd_gotoxy(6,3);
lcd_puts("----------");

s=0;
five=0;
}

if(mrhset==0){
lcd_gotoxy(6,1);
lcd_puts("uR/h");
}

if(mrhset==1){
lcd_gotoxy(6,1);
lcd_puts("mR/h");
}

if(mrhsetfive==0){
lcd_gotoxy(6,2);
lcd_puts("uR/h");
}

if(mrhsetfive==1){
lcd_gotoxy(6,2);
lcd_puts("mR/h");
}






if(setup!=1){
if(five==5){
five=0;
lcd_gotoxy(6,1);
lcd_puts("uR/h");
urhfive=cpfive*38;
urhfive=urhfive*12;
cpfive=0;
urhfive=urhfive/100;
ltoa(urhfive,urhfivec);
 if(urhfive<10){
    lcd_gotoxy(0,2);
    lcd_puts("0000");
    lcd_gotoxy(4,2);
    lcd_puts(urhfivec);  
       
    }      
    
    if(urhfive<100 && urhfive>9){
    lcd_gotoxy(0,2);
    lcd_puts("000");
    lcd_gotoxy(3,2);
    lcd_puts(urhfivec);
    }
    
    if(urhfive<1000 && urhfive>99){
    lcd_gotoxy(0,2);
    lcd_puts("00"); 
    lcd_gotoxy(2,2);
    lcd_puts(urhfivec);
    }
    
    if(urhfive<10000 && urhfive>999){
    lcd_gotoxy(0,2);
    lcd_puts("0"); 
     lcd_gotoxy(1,2);
    lcd_puts(urhfivec);
    }
    
    if(urhfive>9999){
    lcd_gotoxy(0,2);
    lcd_puts(urhfivec);
    }  
       
    
    
     if(urh>99999){
    mrhset=1; 
    
    mrhfive=urhfive/1000;
    ltoa(mrhfive,mrhfivec);
    
    if(mrhfive<10){
    lcd_gotoxy(0,1);
    lcd_puts("0000");
    lcd_gotoxy(4,1);
    lcd_puts(mrhfivec);
    }      
    
    if(mrhfive<100 && mrhfive>9){
    lcd_gotoxy(0,1);
    lcd_puts("000");
    lcd_gotoxy(3,1);
    lcd_puts(mrhfivec);
    }
    
    if(mrhfive<1000 && mrhfive>99){
    lcd_gotoxy(0,1);
    lcd_puts("00"); 
     lcd_gotoxy(2,1);
    lcd_puts(mrhfivec);
    }
    
    if(mrhfive<10000 && mrhfive>999){
    lcd_gotoxy(0,1);
    lcd_puts("0"); 
     lcd_gotoxy(1,1);
    lcd_puts(mrhfivec);
    }
    
    if(mrhfive<100000 && mrhfive>9999){
    lcd_gotoxy(0,1);
    lcd_puts(mrhfivec);
    }  
    
    if(mrhfive>99999){
    lcd_gotoxy(0,1);
    lcd_puts("-over-");
    } 
    mrhset=0; 
    }
    
    
    
    if(urhfive<30){
    lcd_gotoxy(0,3);
    lcd_puts("NORM.");
    }     
    
     if(urhfive>29 && urhfive<1000){
    lcd_gotoxy(0,3);
    lcd_puts("GOOD ");
    }
    
    if(urhfive>1000){
    n=urhfive/1000; 
    
    if(n>1,9){
    itoa(n,nc); 
          
    if(n>99){
    lcd_gotoxy(0,3);
    lcd_puts(nc); 
    }     
    
    if(n>9 && n<100){
    lcd_gotoxy(0,3);
    lcd_puts("0"); 
    lcd_gotoxy(1,3);
    lcd_puts(nc);
    }      
    
    if(n<9){
    lcd_gotoxy(0,3);
    lcd_puts("00"); 
    lcd_gotoxy(2,3);
    lcd_puts(nc);
    }
       
    lcd_gotoxy(4,3);
    lcd_puts("x");
    }  
    }
    
    

                              

}

s++;
sm=60-s;
ltoa(sm,sc);
ltoa(cpm,cpmc);
ltoa(cph,cphc);


if(sm>9){
lcd_gotoxy(7,0);
lcd_puts(sc);
}

if(sm<10){
lcd_gotoxy(7,0);
lcd_puts("0");
lcd_gotoxy(8,0);
lcd_puts(sc);
}



if(s==60){



s=0;
m++;


    if(cpm<10){
    lcd_gotoxy(11,1);
    lcd_puts("0000");
    lcd_gotoxy(15,1);
    lcd_puts(cpmc);
    }      
    
    if(cpm<100 && cpm>9){
    lcd_gotoxy(11,1);
    lcd_puts("000");
    lcd_gotoxy(14,1);
    lcd_puts(cpmc);
    }
    
    if(cpm<1000 && cpm>99){
    lcd_gotoxy(11,1);
    lcd_puts("00"); 
     lcd_gotoxy(13,1);
    lcd_puts(cpmc);
    }
    
    if(cpm<10000 && cpm>999){
    lcd_gotoxy(11,1);
    lcd_puts("0"); 
     lcd_gotoxy(12,1);
    lcd_puts(cpmc);
    }
    
    if(cpm>9999){
    lcd_gotoxy(11,1);
    lcd_puts(cpmc);
    }  
    
    if(cpm>99999){
    lcd_gotoxy(11,1);
    lcd_puts("-over-");
    }   
    
    urh=cpm*38;
    urh=urh/100;
    ltoa(urh,urhc); 
    
      
    
     if(urh<9){
    lcd_gotoxy(0,1);
    lcd_puts("0000");
    lcd_gotoxy(4,1);
    lcd_puts(urhc);
    }      
    
    if(urh<99 && urh>10){
    lcd_gotoxy(0,1);
    lcd_puts("000");
    lcd_gotoxy(3,1);
    lcd_puts(urhc);
    }
    
    if(urh<999 && urh>100){
    lcd_gotoxy(0,1);
    lcd_puts("00"); 
     lcd_gotoxy(2,1);
    lcd_puts(urhc);
    }
    
           
    if(urh>99999){
    mrhset=1; 
    
    mrh=urh/1000;
    ltoa(mrh,mrhc);
    
    if(mrh<9){
    lcd_gotoxy(0,1);
    lcd_puts("0000");
    lcd_gotoxy(4,1);
    lcd_puts(mrhc);
    }      
    
    if(mrh<99 && mrh>10){
    lcd_gotoxy(0,1);
    lcd_puts("000");
    lcd_gotoxy(3,1);
    lcd_puts(mrhc);
    }
    
    if(mrh<999 && mrh>100){
    lcd_gotoxy(0,1);
    lcd_puts("00"); 
     lcd_gotoxy(2,1);
    lcd_puts(mrhc);
    }
    
    if(mrh<9999 && mrh>1000){
    lcd_gotoxy(0,1);
    lcd_puts("0"); 
     lcd_gotoxy(1,1);
    lcd_puts(mrhc);
    }
    
    if(mrh>9999 && mrh<10000){
    lcd_gotoxy(0,1);
    lcd_puts(mrhc);
    }  
    
    if(mrh>99999){
    lcd_gotoxy(0,1);
    lcd_puts("-over-");
    } 
      
    mrhset=0;
    
    } 
     
    cpm=0;
    urh=0; 
    
    
    
  }  
    
if(m==60){
m=0;

    if(cph<10){
    lcd_gotoxy(11,2);
    lcd_puts("0000");
    lcd_gotoxy(15,2);
    lcd_puts(cphc);
    }      
    
    if(cph<100 && cph>9){
    lcd_gotoxy(11,2);
    lcd_puts("000");
    lcd_gotoxy(14,2);
    lcd_puts(cphc);
    }
    
    if(cph<1000 && cph>99){
    lcd_gotoxy(11,2);
    lcd_puts("00"); 
     lcd_gotoxy(13,2);
    lcd_puts(cphc);
    }
    
    if(cph<10000 && cph>999){
    lcd_gotoxy(11,2);
    lcd_puts("0"); 
     lcd_gotoxy(12,2);
    lcd_puts(cphc);
    }
    
    if(cph>9999){
    lcd_gotoxy(11,2);
    lcd_puts(cphc);
    }  
    
    if(cph>99999){
    lcd_gotoxy(11,2);
    lcd_puts("-over-");
    } 
    
    } 
       
    cph=0;

  }
  }
  


  
    
    
   


 

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=t State6=t State5=t State4=t State3=t State2=t State1=t State0=t 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Port E initialization
// Func2=In Func1=In Func0=In 
// State2=T State1=T State0=T 
PORTE=0x00;
DDRE=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=0xFF
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: TOSC1 pin
// Clock value: PCK2/128
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x08;
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

// Timer/Counter 3 initialization
// Clock value: Timer3 Stopped
// Mode: Normal top=0xFFFF
// OC3A output: Discon.
// OC3B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;


// External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Falling edge
// INT2: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-15: Off
GICR|=0x80;
MCUCR=0x08;
EMCUCR=0x00;
GIFR=0x80;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

ETIMSK=0x00;

// USART0 initialization
// USART0 disabled
UCSR0B=0x00;

// USART1 initialization
// USART1 disabled
UCSR1B=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// SPI initialization
// SPI disabled
SPCR=0x00;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTA Bit 0
// RD - PORTA Bit 1
// EN - PORTA Bit 2
// D4 - PORTA Bit 4
// D5 - PORTA Bit 5                                                 
// D6 - PORTA Bit 6
// D7 - PORTA Bit 7
// Characters/line: 20
lcd_init(20);

// Global enable interrupts
#asm("sei")

while(1)
  {
     
   if(PINC.0==1 && PINC.1==1){
   delay_ms(2000); 
   
   if(PINC.0==1 && PINC.1==1){
   delay_ms(2000); 
   if(PINC.0==1 && PINC.1==1){ 
   ctt=0;
   cpm=0;
   cph=0;
   urhfive=0;
   urh=0;
   mrhfive=0;
   urhfive=0;
   license=0;
   setup=1;
   m=0;
   s=0;
   n=0;
   licensesel=0;
   
   }
   }   
   
   }   
 }
 }  
 


